"use strict";

exports.__esModule = true;
exports.useDarkClasses = void 0;

var _react = require("react");

var _TailwindMobileContext = require("./TailwindMobileContext.js");

const useDarkClasses = () => {
  const context = (0, _react.useContext)(_TailwindMobileContext.TailwindMobileContext);
  return classNames => {
    if (!context.dark) return '';
    return classNames;
  };
};

exports.useDarkClasses = useDarkClasses;