"use strict";

exports.__esModule = true;
exports.useTheme = void 0;

var _react = require("react");

var _TailwindMobileContext = require("./TailwindMobileContext.js");

const useTheme = ({
  ios,
  material
} = {}) => {
  const context = (0, _react.useContext)(_TailwindMobileContext.TailwindMobileContext);
  let theme = context.theme || 'ios';
  if (ios) theme = 'ios';
  if (material) theme = 'material';
  return theme;
};

exports.useTheme = useTheme;